//---------------------------------------------------------------------------
// POINTER.HPP
//---------------------------------------------------------------------------
// Revision History
// 08/09/94 - Initial Revision
//---------------------------------------------------------------------------

#if !defined(__POINTER_HPP)
#define __POINTER_HPP

#include <_defs.h>

#define POINTER(name, type, ptr) \
   _POINTER_<type> _ptr_##name(reinterpret_cast<type*>(ptr), 1); \
   type *name = &_ptr_##name

#define UNOWNED_POINTER(name, type, ptr) \
   _POINTER_<type> _ptr_##name(reinterpret_cast<type*>(ptr), 0); \
   type *name = &_ptr_##name

//---------------------------------------------------------------------------
// class: _POINTER_
//---------------------------------------------------------------------------
template<class PTR>
class _EXPCLASS _POINTER_ {
public:
                                 _POINTER_               (PTR* ptr, int own)  {pointer = ptr; dealloc = own; };
   virtual                       ~_POINTER_              (void)               {if (dealloc) delete pointer; };
   PTR *                         operator &              (void)               {return pointer; };

protected:
   int                           dealloc;
   PTR *                         pointer;
private:
                                 _POINTER_                (void);
                                 _POINTER_                (const _POINTER_&);
   _POINTER_ &                   operator =               (const _POINTER_&);
   };


#endif // ___POINTER__HPP
